class TrapTeleporter extends SqRootScript
{

	function Activate(on, sender)
	{
		if (on)
		{
			if (Link.AnyExist("ControlDevice", self))
			{
				local victim = LinkDest(Link.GetOne("ControlDevice", self));
				if (Link.AnyExist("PlayerFactory", victim))
				{
					victim = Object.Named("Player");
				}
				Container.Remove(victim);
				Object.Teleport(victim, vector(0,0,0), vector(0,0,0), self);
				// NewDark 1.27 allows the code below to execute while it had not in prior versions
				// Disable it because it now causes issues
				//Link.DestroyMany("AICurrentPatrol", victim, AnyObject);
			}
		}
	}  

	function HandleMessage(sender)
	{
		local flags = 0;
		local invert = false
		local activated = false;
		if (Property.Possessed(self, "TrapFlags"))
		{
			flags = Property.Get(self, "TrapFlags");
		}
		invert = flags & TRAPF_INVERT;
		if (!Locked.IsLocked(self) && sender != self)
		{
			if (!(flags & TRAPF_NOON))
			{
				Activate(!invert, sender);
				activated = true;
			}
		}
		if (activated && flags & TRAPF_ONCE)
		{
			Property.SetSimple(self, "Locked", true);
		}
	}

	function OnMessage()
	{
		if (MessageIs("TurnOn"))
		{
			HandleMessage(message().from);
		}
	}

	function OnTimer()
	{
		if (message().name == "TurnOn")
		{
			HandleMessage(message().from);
		}
	}

}